
#include "MacroPatternMatch.h"

#include "STDDeletable.h"

#include "GuiTypes.h"

#include "HROOTCoreRectangle_t.h"



#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

DELETABLE_DEF_VIRT(Rectangle_t)
RECTANGLE_T_DEF_VIRT(Rectangle_t)
RECTANGLE_T_DEF_NONVIRT(Rectangle_t)
RECTANGLE_T_DEF_ACCESSOR(Rectangle_t)

