
#include "MacroPatternMatch.h"

#include "STDDeletable.h"

#include "TAtt3D.h"

#include "HROOTCoreTAtt3D.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

DELETABLE_DEF_VIRT(TAtt3D)
TATT3D_DEF_VIRT(TAtt3D)
TATT3D_DEF_NONVIRT(TAtt3D)
TATT3D_DEF_ACCESSOR(TAtt3D)

