
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "HROOT-coreType.h"

#include "STDDeletable.h"

#include "stdcxxType.h"


#define TATTPAD_DECL_VIRT(Type) \
void Type##_ResetAttPad ( Type##_p p, const char* option );\
void Type##_SetBottomMargin ( Type##_p p, float bottommargin );\
void Type##_SetLeftMargin ( Type##_p p, float leftmargin );\
void Type##_SetRightMargin ( Type##_p p, float rightmargin );\
void Type##_SetTopMargin ( Type##_p p, float topmargin );\
void Type##_SetMargin ( Type##_p p, float left, float right, float bottom, float top );\
void Type##_SetAfile ( Type##_p p, float afile );\
void Type##_SetXfile ( Type##_p p, float xfile );\
void Type##_SetYfile ( Type##_p p, float yfile );\
void Type##_SetAstat ( Type##_p p, float astat );\
void Type##_SetXstat ( Type##_p p, float xstat );\
void Type##_SetYstat ( Type##_p p, float ystat );


#define TATTPAD_DECL_NONVIRT(Type) \
Type##_p Type##_newTAttPad (  );\
float Type##_tAttPad_GetBottomMargin ( Type##_p p );\
float Type##_tAttPad_GetLeftMargin ( Type##_p p );\
float Type##_tAttPad_GetRightMargin ( Type##_p p );\
float Type##_tAttPad_GetTopMargin ( Type##_p p );\
float Type##_tAttPad_GetAfile ( Type##_p p );\
float Type##_tAttPad_GetXfile ( Type##_p p );\
float Type##_tAttPad_GetYfile ( Type##_p p );\
float Type##_tAttPad_GetAstat ( Type##_p p );\
float Type##_tAttPad_GetXstat ( Type##_p p );\
float Type##_tAttPad_GetYstat ( Type##_p p );\
short Type##_tAttPad_GetFrameFillColor ( Type##_p p );\
short Type##_tAttPad_GetFrameLineColor ( Type##_p p );\
short Type##_tAttPad_GetFrameFillStyle ( Type##_p p );\
short Type##_tAttPad_GetFrameLineStyle ( Type##_p p );\
short Type##_tAttPad_GetFrameLineWidth ( Type##_p p );\
short Type##_tAttPad_GetFrameBorderSize ( Type##_p p );\
short Type##_tAttPad_GetFrameBorderMode ( Type##_p p );\
void Type##_tAttPad_SetFrameFillColor ( Type##_p p, short color );\
void Type##_tAttPad_SetFrameLineColor ( Type##_p p, short color );\
void Type##_tAttPad_SetFrameFillStyle ( Type##_p p, short styl );\
void Type##_tAttPad_SetFrameLineStyle ( Type##_p p, short styl );\
void Type##_tAttPad_SetFrameLineWidth ( Type##_p p, short width );\
void Type##_tAttPad_SetFrameBorderSize ( Type##_p p, short size );\
void Type##_tAttPad_SetFrameBorderMode ( Type##_p p, int mode );


#define TATTPAD_DECL_ACCESSOR(Type) \



#define TATTPAD_DEF_VIRT(Type) \
void Type##_ResetAttPad ( Type##_p p, const char* option ) {\
((TYPECASTMETHOD(Type, ResetAttPad, TAttPad))(p))->ResetAttPad(option);\
}\
\
void Type##_SetBottomMargin ( Type##_p p, float bottommargin ) {\
((TYPECASTMETHOD(Type, SetBottomMargin, TAttPad))(p))->SetBottomMargin(bottommargin);\
}\
\
void Type##_SetLeftMargin ( Type##_p p, float leftmargin ) {\
((TYPECASTMETHOD(Type, SetLeftMargin, TAttPad))(p))->SetLeftMargin(leftmargin);\
}\
\
void Type##_SetRightMargin ( Type##_p p, float rightmargin ) {\
((TYPECASTMETHOD(Type, SetRightMargin, TAttPad))(p))->SetRightMargin(rightmargin);\
}\
\
void Type##_SetTopMargin ( Type##_p p, float topmargin ) {\
((TYPECASTMETHOD(Type, SetTopMargin, TAttPad))(p))->SetTopMargin(topmargin);\
}\
\
void Type##_SetMargin ( Type##_p p, float left, float right, float bottom, float top ) {\
((TYPECASTMETHOD(Type, SetMargin, TAttPad))(p))->SetMargin(left, right, bottom, top);\
}\
\
void Type##_SetAfile ( Type##_p p, float afile ) {\
((TYPECASTMETHOD(Type, SetAfile, TAttPad))(p))->SetAfile(afile);\
}\
\
void Type##_SetXfile ( Type##_p p, float xfile ) {\
((TYPECASTMETHOD(Type, SetXfile, TAttPad))(p))->SetXfile(xfile);\
}\
\
void Type##_SetYfile ( Type##_p p, float yfile ) {\
((TYPECASTMETHOD(Type, SetYfile, TAttPad))(p))->SetYfile(yfile);\
}\
\
void Type##_SetAstat ( Type##_p p, float astat ) {\
((TYPECASTMETHOD(Type, SetAstat, TAttPad))(p))->SetAstat(astat);\
}\
\
void Type##_SetXstat ( Type##_p p, float xstat ) {\
((TYPECASTMETHOD(Type, SetXstat, TAttPad))(p))->SetXstat(xstat);\
}\
\
void Type##_SetYstat ( Type##_p p, float ystat ) {\
((TYPECASTMETHOD(Type, SetYstat, TAttPad))(p))->SetYstat(ystat);\
}


#define TATTPAD_DEF_NONVIRT(Type) \
Type##_p Type##_newTAttPad (  ) {\
Type* newp=new Type();return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}\
\
float Type##_tAttPad_GetBottomMargin ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetBottomMargin, TAttPad))(p))->GetBottomMargin();\
}\
\
float Type##_tAttPad_GetLeftMargin ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetLeftMargin, TAttPad))(p))->GetLeftMargin();\
}\
\
float Type##_tAttPad_GetRightMargin ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetRightMargin, TAttPad))(p))->GetRightMargin();\
}\
\
float Type##_tAttPad_GetTopMargin ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetTopMargin, TAttPad))(p))->GetTopMargin();\
}\
\
float Type##_tAttPad_GetAfile ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetAfile, TAttPad))(p))->GetAfile();\
}\
\
float Type##_tAttPad_GetXfile ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetXfile, TAttPad))(p))->GetXfile();\
}\
\
float Type##_tAttPad_GetYfile ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetYfile, TAttPad))(p))->GetYfile();\
}\
\
float Type##_tAttPad_GetAstat ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetAstat, TAttPad))(p))->GetAstat();\
}\
\
float Type##_tAttPad_GetXstat ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetXstat, TAttPad))(p))->GetXstat();\
}\
\
float Type##_tAttPad_GetYstat ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetYstat, TAttPad))(p))->GetYstat();\
}\
\
short Type##_tAttPad_GetFrameFillColor ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetFrameFillColor, TAttPad))(p))->GetFrameFillColor();\
}\
\
short Type##_tAttPad_GetFrameLineColor ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetFrameLineColor, TAttPad))(p))->GetFrameLineColor();\
}\
\
short Type##_tAttPad_GetFrameFillStyle ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetFrameFillStyle, TAttPad))(p))->GetFrameFillStyle();\
}\
\
short Type##_tAttPad_GetFrameLineStyle ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetFrameLineStyle, TAttPad))(p))->GetFrameLineStyle();\
}\
\
short Type##_tAttPad_GetFrameLineWidth ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetFrameLineWidth, TAttPad))(p))->GetFrameLineWidth();\
}\
\
short Type##_tAttPad_GetFrameBorderSize ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetFrameBorderSize, TAttPad))(p))->GetFrameBorderSize();\
}\
\
short Type##_tAttPad_GetFrameBorderMode ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tAttPad_GetFrameBorderMode, TAttPad))(p))->GetFrameBorderMode();\
}\
\
void Type##_tAttPad_SetFrameFillColor ( Type##_p p, short color ) {\
((TYPECASTMETHOD(Type, tAttPad_SetFrameFillColor, TAttPad))(p))->SetFrameFillColor(color);\
}\
\
void Type##_tAttPad_SetFrameLineColor ( Type##_p p, short color ) {\
((TYPECASTMETHOD(Type, tAttPad_SetFrameLineColor, TAttPad))(p))->SetFrameLineColor(color);\
}\
\
void Type##_tAttPad_SetFrameFillStyle ( Type##_p p, short styl ) {\
((TYPECASTMETHOD(Type, tAttPad_SetFrameFillStyle, TAttPad))(p))->SetFrameFillStyle(styl);\
}\
\
void Type##_tAttPad_SetFrameLineStyle ( Type##_p p, short styl ) {\
((TYPECASTMETHOD(Type, tAttPad_SetFrameLineStyle, TAttPad))(p))->SetFrameLineStyle(styl);\
}\
\
void Type##_tAttPad_SetFrameLineWidth ( Type##_p p, short width ) {\
((TYPECASTMETHOD(Type, tAttPad_SetFrameLineWidth, TAttPad))(p))->SetFrameLineWidth(width);\
}\
\
void Type##_tAttPad_SetFrameBorderSize ( Type##_p p, short size ) {\
((TYPECASTMETHOD(Type, tAttPad_SetFrameBorderSize, TAttPad))(p))->SetFrameBorderSize(size);\
}\
\
void Type##_tAttPad_SetFrameBorderMode ( Type##_p p, int mode ) {\
((TYPECASTMETHOD(Type, tAttPad_SetFrameBorderMode, TAttPad))(p))->SetFrameBorderMode(mode);\
}


#define TATTPAD_DEF_ACCESSOR(Type) \



DELETABLE_DECL_VIRT(TAttPad)
TATTPAD_DECL_VIRT(TAttPad)
TATTPAD_DECL_NONVIRT(TAttPad)
TATTPAD_DECL_ACCESSOR(TAttPad)

#ifdef __cplusplus
}
#endif

