
#include "MacroPatternMatch.h"

#include "STDDeletable.h"

#include "TDatime.h"

#include "HROOTCoreTDatime.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

DELETABLE_DEF_VIRT(TDatime)
TDATIME_DEF_VIRT(TDatime)
TDATIME_DEF_NONVIRT(TDatime)
TDATIME_DEF_ACCESSOR(TDatime)

