
#include "MacroPatternMatch.h"

#include "HROOTCoreTNamed.h"

#include "TDictionary.h"

#include "HROOTCoreTDictionary.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TDictionary)
TOBJECT_DEF_VIRT(TDictionary)
DELETABLE_DEF_VIRT(TDictionary)
TDICTIONARY_DEF_NONVIRT(TDictionary)
TDICTIONARY_DEF_ACCESSOR(TDictionary)

