
#include "MacroPatternMatch.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttMarker.h"

#include "HROOTCoreTAttText.h"

#include "TStyle.h"

#include "HROOTCoreTStyle.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TStyle)
TATTLINE_DEF_VIRT(TStyle)
TATTFILL_DEF_VIRT(TStyle)
TATTMARKER_DEF_VIRT(TStyle)
TATTTEXT_DEF_VIRT(TStyle)
TOBJECT_DEF_VIRT(TStyle)
DELETABLE_DEF_VIRT(TStyle)
TSTYLE_DEF_VIRT(TStyle)
TSTYLE_DEF_NONVIRT(TStyle)
TSTYLE_DEF_ACCESSOR(TStyle)

