{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TApplication.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TApplication.RawType
import HROOT.Core.TObject.Interface
import HROOT.Core.TQObject.Interface

class (ITObject a, ITQObject a) => ITApplication a where
        run :: () => a -> CBool -> IO ()

upcastTApplication ::
                   forall a . (FPtr a, ITApplication a) => a -> TApplication
upcastTApplication h
  = let fh = get_fptr h
        fh2 :: Ptr RawTApplication = castPtr fh
      in cast_fptr_to_obj fh2

downcastTApplication ::
                     forall a . (FPtr a, ITApplication a) => TApplication -> a
downcastTApplication h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
