{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TArray.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.FFI
import HROOT.Core.TArray.Interface
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITArray (TArray) where
        getAt = xform1 c_tarray_getat
        setArray = xform1 c_tarray_setarray
        setAt = xform2 c_tarray_setat

instance () => IDeletable (TArray) where
        delete = xform0 c_tarray_delete

tArray_GetSize :: () => TArray -> IO CInt
tArray_GetSize = xform0 c_tarray_tarray_getsize
