{-# LANGUAGE ForeignFunctionInterface, TypeFamilies,
  MultiParamTypeClasses, FlexibleInstances, TypeSynonymInstances,
  EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}
module HROOT.Core.TArray.RawType where
import Foreign.Ptr
import FFICXX.Runtime.Cast

data RawTArray

newtype TArray = TArray (Ptr RawTArray)
                   deriving (Eq, Ord, Show)

instance () => FPtr (TArray) where
        type Raw TArray = RawTArray
        get_fptr (TArray ptr) = ptr
        cast_fptr_to_obj = TArray
