{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TAttText.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TAttText.RawType
import HROOT.Core.TAttText.RawType

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_delete" c_tatttext_delete ::
               Ptr RawTAttText -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_newTAttText" c_tatttext_newtatttext
               ::
               CInt ->
                 CFloat -> CShort -> CShort -> CFloat -> IO (Ptr RawTAttText)

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_GetTextAlign" c_tatttext_gettextalign
               :: Ptr RawTAttText -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_GetTextAngle" c_tatttext_gettextangle
               :: Ptr RawTAttText -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_GetTextColor" c_tatttext_gettextcolor
               :: Ptr RawTAttText -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_GetTextFont" c_tatttext_gettextfont
               :: Ptr RawTAttText -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_GetTextSize" c_tatttext_gettextsize
               :: Ptr RawTAttText -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_ResetAttText" c_tatttext_resetatttext
               :: Ptr RawTAttText -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_SetTextAttributes"
               c_tatttext_settextattributes :: Ptr RawTAttText -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_SetTextAlign" c_tatttext_settextalign
               :: Ptr RawTAttText -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_SetTextAngle" c_tatttext_settextangle
               :: Ptr RawTAttText -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_SetTextColor" c_tatttext_settextcolor
               :: Ptr RawTAttText -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_SetTextFont" c_tatttext_settextfont
               :: Ptr RawTAttText -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_SetTextSize" c_tatttext_settextsize
               :: Ptr RawTAttText -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttText.h TAttText_SetTextSizePixels"
               c_tatttext_settextsizepixels :: Ptr RawTAttText -> CInt -> IO ()
