{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TSeqCollection.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TSeqCollection.RawType
import HROOT.Core.TCollection.Interface

class (ITCollection a) => ITSeqCollection a where

upcastTSeqCollection ::
                     forall a . (FPtr a, ITSeqCollection a) => a -> TSeqCollection
upcastTSeqCollection h
  = let fh = get_fptr h
        fh2 :: Ptr RawTSeqCollection = castPtr fh
      in cast_fptr_to_obj fh2

downcastTSeqCollection ::
                       forall a . (FPtr a, ITSeqCollection a) => TSeqCollection -> a
downcastTSeqCollection h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
