
#include "MacroPatternMatch.h"

#include "STDDeletable.h"

#include "TArray.h"

#include "HROOTCoreTArray.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

DELETABLE_DEF_VIRT(TArray)
TARRAY_DEF_VIRT(TArray)
TARRAY_DEF_NONVIRT(TArray)
TARRAY_DEF_ACCESSOR(TArray)

