
#include "MacroPatternMatch.h"

#include "HROOTCoreTArray.h"

#include "TArrayS.h"

#include "HROOTCoreTArrayS.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TARRAY_DEF_VIRT(TArrayS)
DELETABLE_DEF_VIRT(TArrayS)
TARRAYS_DEF_VIRT(TArrayS)
TARRAYS_DEF_NONVIRT(TArrayS)
TARRAYS_DEF_ACCESSOR(TArrayS)

