
#include "MacroPatternMatch.h"

#include "HROOTCoreTDictionary.h"

#include "TClass.h"

#include "HROOTCoreTClass.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TDICTIONARY_DEF_VIRT(TClass)
TNAMED_DEF_VIRT(TClass)
TOBJECT_DEF_VIRT(TClass)
DELETABLE_DEF_VIRT(TClass)
TCLASS_DEF_VIRT(TClass)
TCLASS_DEF_NONVIRT(TClass)
TCLASS_DEF_ACCESSOR(TClass)

