
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "HROOT-coreType.h"

#include "STDDeletable.h"

#include "stdcxxType.h"


#define TDATIME_DECL_VIRT(Type) \
unsigned int Type##_Convert ( Type##_p p, bool toGMT );\
void Type##_setTDatime ( Type##_p p, unsigned int tloc );


#define TDATIME_DECL_NONVIRT(Type) \
Type##_p Type##_newTDatime ( int year, int month, int day, int hour, int min, int sec );\
int Type##_tDatime_GetDay ( Type##_p p );\
int Type##_tDatime_GetHour ( Type##_p p );\
int Type##_tDatime_GetMinute ( Type##_p p );\
int Type##_tDatime_GetSecond ( Type##_p p );\
int Type##_tDatime_GetYear ( Type##_p p );\
int Type##_tDatime_GetMonth ( Type##_p p );


#define TDATIME_DECL_ACCESSOR(Type) \



#define TDATIME_DEF_VIRT(Type) \
unsigned int Type##_Convert ( Type##_p p, bool toGMT ) {\
return ((TYPECASTMETHOD(Type, Convert, TDatime))(p))->Convert(toGMT);\
}\
\
void Type##_setTDatime ( Type##_p p, unsigned int tloc ) {\
((TYPECASTMETHOD(Type, setTDatime, TDatime))(p))->Set(tloc);\
}


#define TDATIME_DEF_NONVIRT(Type) \
Type##_p Type##_newTDatime ( int year, int month, int day, int hour, int min, int sec ) {\
Type* newp=new Type(year, month, day, hour, min, sec);return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}\
\
int Type##_tDatime_GetDay ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tDatime_GetDay, TDatime))(p))->GetDay();\
}\
\
int Type##_tDatime_GetHour ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tDatime_GetHour, TDatime))(p))->GetHour();\
}\
\
int Type##_tDatime_GetMinute ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tDatime_GetMinute, TDatime))(p))->GetMinute();\
}\
\
int Type##_tDatime_GetSecond ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tDatime_GetSecond, TDatime))(p))->GetSecond();\
}\
\
int Type##_tDatime_GetYear ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tDatime_GetYear, TDatime))(p))->GetYear();\
}\
\
int Type##_tDatime_GetMonth ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, tDatime_GetMonth, TDatime))(p))->GetMonth();\
}


#define TDATIME_DEF_ACCESSOR(Type) \



DELETABLE_DECL_VIRT(TDatime)
TDATIME_DECL_VIRT(TDatime)
TDATIME_DECL_NONVIRT(TDatime)
TDATIME_DECL_ACCESSOR(TDatime)

#ifdef __cplusplus
}
#endif

