
#include "MacroPatternMatch.h"

#include "HROOTCoreTSeqCollection.h"

#include "TObjArray.h"

#include "HROOTCoreTObjArray.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TSEQCOLLECTION_DEF_VIRT(TObjArray)
TCOLLECTION_DEF_VIRT(TObjArray)
TOBJECT_DEF_VIRT(TObjArray)
DELETABLE_DEF_VIRT(TObjArray)
TOBJARRAY_DEF_VIRT(TObjArray)
TOBJARRAY_DEF_NONVIRT(TObjArray)
TOBJARRAY_DEF_ACCESSOR(TObjArray)

