
#include "MacroPatternMatch.h"

#include "HROOTCoreTCollection.h"

#include "TSeqCollection.h"

#include "HROOTCoreTSeqCollection.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TCOLLECTION_DEF_VIRT(TSeqCollection)
TOBJECT_DEF_VIRT(TSeqCollection)
DELETABLE_DEF_VIRT(TSeqCollection)
TSEQCOLLECTION_DEF_VIRT(TSeqCollection)
TSEQCOLLECTION_DEF_NONVIRT(TSeqCollection)
TSEQCOLLECTION_DEF_ACCESSOR(TSeqCollection)

