
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "HROOT-coreType.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttMarker.h"

#include "HROOTCoreTAttText.h"

#include "HROOTCoreTObject.h"

#include "STDDeletable.h"


#define TSTYLE_DECL_VIRT(Type) \



#define TSTYLE_DECL_NONVIRT(Type) \
void Type##_tStyle_SetCanvasPreferGL ( Type##_p p, bool prefer );\
void Type##_tStyle_SetOptDate ( Type##_p p, int optdate );\
void Type##_tStyle_SetOptFile ( Type##_p p, int file );\
void Type##_tStyle_SetOptFit ( Type##_p p, int mode );\
void Type##_tStyle_SetOptLogx ( Type##_p p, int logx );\
void Type##_tStyle_SetOptLogy ( Type##_p p, int logy );\
void Type##_tStyle_SetOptLogz ( Type##_p p, int logz );\
void Type##_tStyle_SetOptStat ( Type##_p p, int mode );\
void Type##_tStyle_SetOptTitle ( Type##_p p, int tit );\
void Type##_tStyle_SetPalette ( Type##_p p, int ncolors );


#define TSTYLE_DECL_ACCESSOR(Type) \



#define TSTYLE_DEF_VIRT(Type) \



#define TSTYLE_DEF_NONVIRT(Type) \
void Type##_tStyle_SetCanvasPreferGL ( Type##_p p, bool prefer ) {\
((TYPECASTMETHOD(Type, tStyle_SetCanvasPreferGL, TStyle))(p))->SetCanvasPreferGL(prefer);\
}\
\
void Type##_tStyle_SetOptDate ( Type##_p p, int optdate ) {\
((TYPECASTMETHOD(Type, tStyle_SetOptDate, TStyle))(p))->SetOptDate(optdate);\
}\
\
void Type##_tStyle_SetOptFile ( Type##_p p, int file ) {\
((TYPECASTMETHOD(Type, tStyle_SetOptFile, TStyle))(p))->SetOptFile(file);\
}\
\
void Type##_tStyle_SetOptFit ( Type##_p p, int mode ) {\
((TYPECASTMETHOD(Type, tStyle_SetOptFit, TStyle))(p))->SetOptFit(mode);\
}\
\
void Type##_tStyle_SetOptLogx ( Type##_p p, int logx ) {\
((TYPECASTMETHOD(Type, tStyle_SetOptLogx, TStyle))(p))->SetOptLogx(logx);\
}\
\
void Type##_tStyle_SetOptLogy ( Type##_p p, int logy ) {\
((TYPECASTMETHOD(Type, tStyle_SetOptLogy, TStyle))(p))->SetOptLogy(logy);\
}\
\
void Type##_tStyle_SetOptLogz ( Type##_p p, int logz ) {\
((TYPECASTMETHOD(Type, tStyle_SetOptLogz, TStyle))(p))->SetOptLogz(logz);\
}\
\
void Type##_tStyle_SetOptStat ( Type##_p p, int mode ) {\
((TYPECASTMETHOD(Type, tStyle_SetOptStat, TStyle))(p))->SetOptStat(mode);\
}\
\
void Type##_tStyle_SetOptTitle ( Type##_p p, int tit ) {\
((TYPECASTMETHOD(Type, tStyle_SetOptTitle, TStyle))(p))->SetOptTitle(tit);\
}\
\
void Type##_tStyle_SetPalette ( Type##_p p, int ncolors ) {\
((TYPECASTMETHOD(Type, tStyle_SetPalette, TStyle))(p))->SetPalette(ncolors);\
}


#define TSTYLE_DEF_ACCESSOR(Type) \



TNAMED_DECL_VIRT(TStyle)
TATTLINE_DECL_VIRT(TStyle)
TATTFILL_DECL_VIRT(TStyle)
TATTMARKER_DECL_VIRT(TStyle)
TATTTEXT_DECL_VIRT(TStyle)
TOBJECT_DECL_VIRT(TStyle)
DELETABLE_DECL_VIRT(TStyle)
TSTYLE_DECL_VIRT(TStyle)
TSTYLE_DECL_NONVIRT(TStyle)
TSTYLE_DECL_ACCESSOR(TStyle)

#ifdef __cplusplus
}
#endif

