{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TApplication.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TApplication.RawType
import HROOT.Core.TApplication.FFI
import HROOT.Core.TApplication.Interface
import HROOT.Core.TApplication.Cast
import HROOT.Core.TApplication.RawType
import HROOT.Core.TApplication.Cast
import HROOT.Core.TApplication.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TQObject.RawType
import HROOT.Core.TQObject.Cast
import HROOT.Core.TQObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITApplication (TApplication) where
        run = xform1 c_tapplication_run

instance () => ITObject (TApplication) where
        clear = xform1 c_tapplication_clear
        draw = xform1 c_tapplication_draw
        findObject = xform1 c_tapplication_findobject
        getName = xform0 c_tapplication_getname
        isA = xform0 c_tapplication_isa
        paint = xform1 c_tapplication_paint
        printObj = xform1 c_tapplication_printobj
        saveAs = xform2 c_tapplication_saveas
        write = xform3 c_tapplication_write
        write_ = xform0 c_tapplication_write_

instance () => ITQObject (TApplication) where

instance () => IDeletable (TApplication) where
        delete = xform0 c_tapplication_delete

newTApplication ::
                  (Castable c0 CString) =>
                  c0 -> Ptr CInt -> Ptr CString -> IO TApplication
newTApplication = xform2 c_tapplication_newtapplication
