{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TArrayF.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TArrayF.RawType
import HROOT.Core.TArrayF.RawType

foreign import ccall interruptible
               "HROOTCoreTArrayF.h TArrayF_GetAt" c_tarrayf_getat ::
               Ptr RawTArrayF -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTCoreTArrayF.h TArrayF_SetArray" c_tarrayf_setarray ::
               Ptr RawTArrayF -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayF.h TArrayF_SetAt" c_tarrayf_setat ::
               Ptr RawTArrayF -> CDouble -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayF.h TArrayF_delete" c_tarrayf_delete ::
               Ptr RawTArrayF -> IO ()
