{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TArrayI.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TArrayI.RawType
import HROOT.Core.TArray.Interface

class (ITArray a) => ITArrayI a where

upcastTArrayI :: forall a . (FPtr a, ITArrayI a) => a -> TArrayI
upcastTArrayI h
  = let fh = get_fptr h
        fh2 :: Ptr RawTArrayI = castPtr fh
      in cast_fptr_to_obj fh2

downcastTArrayI :: forall a . (FPtr a, ITArrayI a) => TArrayI -> a
downcastTArrayI h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
