{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TArrayS.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TArrayS.RawType
import HROOT.Core.TArrayS.RawType

foreign import ccall interruptible
               "HROOTCoreTArrayS.h TArrayS_GetAt" c_tarrays_getat ::
               Ptr RawTArrayS -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTCoreTArrayS.h TArrayS_SetArray" c_tarrays_setarray ::
               Ptr RawTArrayS -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayS.h TArrayS_SetAt" c_tarrays_setat ::
               Ptr RawTArrayS -> CDouble -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayS.h TArrayS_delete" c_tarrays_delete ::
               Ptr RawTArrayS -> IO ()
