{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAtt3D.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAtt3D.RawType
import STD.Deletable.Interface

class (IDeletable a) => ITAtt3D a where

upcastTAtt3D :: forall a . (FPtr a, ITAtt3D a) => a -> TAtt3D
upcastTAtt3D h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAtt3D = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAtt3D :: forall a . (FPtr a, ITAtt3D a) => TAtt3D -> a
downcastTAtt3D h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
