{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TClass.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.RawType
import HROOT.Core.TObject.RawType

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_SetName" c_tclass_setname ::
               Ptr RawTClass -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_SetNameTitle" c_tclass_setnametitle ::
               Ptr RawTClass -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_SetTitle" c_tclass_settitle ::
               Ptr RawTClass -> CString -> IO ()

foreign import ccall interruptible "HROOTCoreTClass.h TClass_Clear"
               c_tclass_clear :: Ptr RawTClass -> CString -> IO ()

foreign import ccall interruptible "HROOTCoreTClass.h TClass_Draw"
               c_tclass_draw :: Ptr RawTClass -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_FindObject" c_tclass_findobject ::
               Ptr RawTClass -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_GetName" c_tclass_getname ::
               Ptr RawTClass -> IO CString

foreign import ccall interruptible "HROOTCoreTClass.h TClass_IsA"
               c_tclass_isa :: Ptr RawTClass -> IO (Ptr RawTClass)

foreign import ccall interruptible "HROOTCoreTClass.h TClass_Paint"
               c_tclass_paint :: Ptr RawTClass -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_printObj" c_tclass_printobj ::
               Ptr RawTClass -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_SaveAs" c_tclass_saveas ::
               Ptr RawTClass -> CString -> CString -> IO ()

foreign import ccall interruptible "HROOTCoreTClass.h TClass_Write"
               c_tclass_write ::
               Ptr RawTClass -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_Write_" c_tclass_write_ ::
               Ptr RawTClass -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTClass.h TClass_delete" c_tclass_delete ::
               Ptr RawTClass -> IO ()
