{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TGlobal.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TGlobal.RawType
import HROOT.Core.TGlobal.FFI
import HROOT.Core.TGlobal.Interface
import HROOT.Core.TGlobal.Cast
import HROOT.Core.TGlobal.RawType
import HROOT.Core.TGlobal.Cast
import HROOT.Core.TGlobal.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TDictionary.RawType
import HROOT.Core.TDictionary.Cast
import HROOT.Core.TDictionary.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITGlobal (TGlobal) where

instance () => ITDictionary (TGlobal) where

instance () => ITNamed (TGlobal) where
        setName = xform1 c_tglobal_setname
        setNameTitle = xform2 c_tglobal_setnametitle
        setTitle = xform1 c_tglobal_settitle

instance () => ITObject (TGlobal) where
        clear = xform1 c_tglobal_clear
        draw = xform1 c_tglobal_draw
        findObject = xform1 c_tglobal_findobject
        getName = xform0 c_tglobal_getname
        isA = xform0 c_tglobal_isa
        paint = xform1 c_tglobal_paint
        printObj = xform1 c_tglobal_printobj
        saveAs = xform2 c_tglobal_saveas
        write = xform3 c_tglobal_write
        write_ = xform0 c_tglobal_write_

instance () => IDeletable (TGlobal) where
        delete = xform0 c_tglobal_delete
