{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TObjArray.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TSeqCollection.Interface

class (ITSeqCollection a) => ITObjArray a where

upcastTObjArray ::
                forall a . (FPtr a, ITObjArray a) => a -> TObjArray
upcastTObjArray h
  = let fh = get_fptr h
        fh2 :: Ptr RawTObjArray = castPtr fh
      in cast_fptr_to_obj fh2

downcastTObjArray ::
                  forall a . (FPtr a, ITObjArray a) => TObjArray -> a
downcastTObjArray h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
