{-# LANGUAGE ForeignFunctionInterface, TypeFamilies,
  MultiParamTypeClasses, FlexibleInstances, TypeSynonymInstances,
  EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}
module HROOT.Core.TObject.RawType where
import Foreign.Ptr
import FFICXX.Runtime.Cast

data RawTObject

newtype TObject = TObject (Ptr RawTObject)
                    deriving (Eq, Ord, Show)

instance () => FPtr (TObject) where
        type Raw TObject = RawTObject
        get_fptr (TObject ptr) = ptr
        cast_fptr_to_obj = TObject
